from azmlclient.base_databinding import AzmlException
# do not import since azure-storage package is optional
# from azmlclient.base_databinding_blobs import BlobConverters, BlobCollectionConverters
from azmlclient.base import execute_rr, execute_bes, IllegalJobStateException, JobExecutionException, \
    create_session_for_proxy, create_session_for_proxy_from_strings, RequestResponseClient, BatchClient

from azmlclient.clients_config import GlobalConfig, ServiceConfig, ClientConfig, ConfigTemplateSyntaxError
from azmlclient.clients_callmodes import CallMode, RemoteCallMode, RequestResponse, Batch
from azmlclient.clients import AzureMLClient, azureml_service, unpack_single_value_from_df, LocalCallModeNotAllowed

try:
    # Distribution mode : import from _version.py generated by setuptools_scm during release
    from ._version import version as __version__
except ImportError:
    # Source mode : use setuptools_scm to get the current version from src using git
    from setuptools_scm import get_version as _gv
    from os import path as _path
    __version__ = _gv(_path.join(_path.dirname(__file__), _path.pardir))

__all__ = [
    '__version__',
    # submodules
    'base_databinding', 'base', 'clients', 'clients_callmodes', 'clients_config',  # 'base_databinding_blobs'
    # symbols imported above
    # -- base_databinding
    'AzmlException',
    # -- base databinding blob:  do not import since azure-storage package is optional
    #'BlobConverters', 'BlobCollectionConverters',
    # -- base
    'execute_rr', 'execute_bes', 'IllegalJobStateException', 'JobExecutionException', 'create_session_for_proxy',
    'RequestResponseClient', 'BatchClient', 'create_session_for_proxy_from_strings',
    # -- clients_config
    'GlobalConfig', 'ServiceConfig', 'ClientConfig', 'ConfigTemplateSyntaxError',
    # -- clients_callmodes
    'CallMode', 'RemoteCallMode', 'RequestResponse', 'Batch',
    # -- clients
    'AzureMLClient', 'azureml_service', 'unpack_single_value_from_df', 'LocalCallModeNotAllowed'
]
